local mapMod = foundation.createMod();

-- registering map files
mapMod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")
mapMod:registerAssetId("maps/tree_density_map1.png", "TREE_DENSITY_MAP1")
mapMod:registerAssetId("maps/tree_density_map2.png", "TREE_DENSITY_MAP2")
mapMod:registerAssetId("maps/tree_density_map3.png", "TREE_DENSITY_MAP3")
mapMod:registerAssetId("maps/tree_density_map4.png", "TREE_DENSITY_MAP4")

-- register custom map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "RIVERY_ID",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -20,
	MaxHeight = 80,
	VillagePathList = {
		{
			Entrance = { 3, 0, 544 },
			Exit = { 539, 0, 342 },
		}
	},
	SpawnList = {
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 317 , 59 , 695 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 157 , 59 , 511 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 143 , 26 , 146 },
			Orientation = { 0.0, -0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 714 , 31 , 398 },
			Orientation = { 0.0, 90.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 714 , 31 , 378 },
			Orientation = { 0.0, -90.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		}
	},
	DensitySpawnList = {
			{
			-- creating Tree Density Map1
			DensityMap = "TREE_DENSITY_MAP1",
			Density = 0.51,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_OAK" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.2,0.4,0.2,1 },
							Max = { 0.4,0.8,0.4,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map2
			DensityMap = "TREE_DENSITY_MAP2",
			Density = 0.61,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_SYCAMORE" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map3
			DensityMap = "TREE_DENSITY_MAP3",
			Density = 0.51,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_POPLAR" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map4
			DensityMap = "TREE_DENSITY_MAP4",
			Density = 0.31,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.2,1 },
							Max = { 0.8,0.8,0.4,1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_BERRIES" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
-- This map was created with the help of the UFME
